*-----------------------------------------------------------
* Title      : Passing Arguments using Stack
* Written by : D. Karampatzakis, based on A.Moshovos material
* Date       : Dec 2019
* Description:
*-----------------------------------------------------------
            ORG $20080
SUM         DC.L 0            


            ORG $20000
                                ; Pre-call section
MAIN        MOVE.L #3,-(SP)     ; push third argument onto the stack
            MOVE.L #2,-(SP)     ; push second argument onto the stack
            MOVE.L #1,-(SP)     ; push first argument onto the stack
 
            JSR ADD3            ; call the subroutine
                                ; this also pushes the return address onto the stack
                                ; post-call section
RETADD      ADDA.L #12,SP       ; deallocate the stack space used for the parameters
                                ; we pushed four long words in the pre-call section
                                ; thus by adding 12 to the stack pointer we are essentially removing these four long words off the stack
            MOVE.L SUM,D1       ; read sum into d1
            ADD.L  D0,D1        ; add to d1 the value returned by add3 (in d0)
            MOVE.L D1,SUM       ; write the result back to sum in memory
            RTS
ADD3        MOVE.L 12(SP),D0    ; read parameter c (the third) into d0. This is at distance 12 from the top of the stack (see preceding figure)
            ADD.L  8(SP),D0     ; add the second parameter to d0.
            ADD.L  4(SP),D0     ; add the first parameter to d0
            RTS                 ; return to the caller
            END MAIN



*~Font name~Courier New~
*~Font size~12~
*~Tab type~1~
*~Tab size~4~
