*----------------------------------------------------------------
* Title      : Callee Saver - Subroutines
* Written by : D. Karampatzakis, based on A.Moshovos material
* Date       : Dec 2019
* Description: subroutine saves the registers on the stack 
*----------------------------------------------------------------
            ORG $20080
SUM         DC.L 0            


            ORG $20000
                                ; Pre-call section (The Caller)
MAIN        CLR.L  D3           ; temporary SUM=0
            MOVE.L #3,-(SP)     ; push third argument onto the stack
            MOVE.L #2,-(SP)     ; push second argument onto the stack
            MOVE.L #1,-(SP)     ; push first argument onto the stack
 
            JSR ADD3            ; call the subroutine
                                ; this also pushes the return address onto the stack
                                ; post-call section
RETADD      ADDA.L #12,SP       ; deallocate the stack space used for the parameters
                               
            
            ADD.L  D0,D3        ; add return value temporary SUM
            MOVE.L D3,SUM       ; write sum into memory
            RTS

ADD3        MOVE.L D3,-(SP)     ; PROLOGUE - save d3's value onto the stack (The Callee)
                                ; main body
            MOVE.L 8(SP),D3     ; copy first parameter from the stack to D3
            ADD.L  12(SP),D3    ; add the second parameter to D3
            ADD.L  16(SP),D3    ; add the third parameter to D3
            MOVE.L D3,D0        ; move SUM into D0 since caller expects the return value there
            MOVE.L (SP)+,D3     ; EPILOGUE - restore D3's original value
            RTS                 ; return to the caller
            END MAIN




*~Font name~Courier New~
*~Font size~12~
*~Tab type~1~
*~Tab size~4~
