*----------------------------------------------------------------
* Title      : Caller Saver - Subroutines
* Written by : D. Karampatzakis, based on A.Moshovos material
* Date       : Dec 2019
* Description: Register d3 is saved by the Caller, not the Callee
*----------------------------------------------------------------
            ORG $20080
SUM         DC.L 0            


            ORG $20000
                                ; Pre-call section (The Caller)
MAIN        CLR.L  D3           ; temporary SUM=0
            MOVE.L D3,-(SP)     ; main saves d3 since we assume it is a caller saved register, thus it may change during the call to add3
            MOVE.L #3,-(SP)     ; push third argument onto the stack
            MOVE.L #2,-(SP)     ; push second argument onto the stack
            MOVE.L #1,-(SP)     ; push first argument onto the stack
 
            JSR ADD3            ; call the subroutine
                                ; this also pushes the return address onto the stack
                                ; post-call section
RETADD      ADDA.L #12,SP       ; deallocate the stack space used for the parameters
            MOVE.L (SP)+,D3     ; main restores d3, now d3 has the value it had just before the preceding jsr add3 statement                   
            
            MOVE.L D0,SUM       ; write sum into memory
            RTS

ADD3                            ; main body
            MOVE.L 4(SP),D3     ; copy first parameter from the stack to D3
            ADD.L  8(SP),D3     ; add the second parameter to D3
            ADD.L  12(SP),D3    ; add the third parameter to D3
            MOVE.L D3,D0        ; move SUM into D0 since caller expects the return value there
            RTS                 ; return to the caller
            END MAIN


*~Font name~Courier New~
*~Font size~12~
*~Tab type~1~
*~Tab size~4~
